/***********************************************************
*                      K O U L E S                         *
*----------------------------------------------------------*
*  C1995 JAHUSOFT                                          *
*        Jan Hubicka                                       *
*        Dukelskych Bojovniku 1944                         *
*        390 03 Tabor                                      *
*        Czech Republic                                    *
*        Phone: 0041-361-32613                             *
*        eMail: hubicka@limax.paru.cas.cz                  *
*----------------------------------------------------------*
*   Copyright(c)1995,1996 by Jan Hubicka.See README for    *
*                    licence details.                      *
*----------------------------------------------------------*
*  interface.h   interface for svgalib                     *
***********************************************************/
#include <allegro.h>

extern BITMAP *CURSCR;
extern int VIDEOWIDTH,VIDEOHEIGHT;

#ifdef MOUSE
/* #include <vgamouse.h>*/
#endif
#include <input.h>
#define EYE_RADIUS (DIV==1?5:6)
#define MOUSE_RADIUS 4

typedef char *RawBitmapType;
typedef RLE_SPRITE *BitmapType;
typedef BITMAP *VScreenType;


#ifndef PLATFORM_VARIABLES_HERE
extern int      GAMEWIDTH;
extern int      GAMEHEIGHT;
extern int      MAPWIDTH;
extern int      MAPHEIGHT;
extern int      DIV;

extern int      flipping;
extern int      page;

extern void    *fontblack;
extern void    *fontwhite;
extern VScreenType physicalscreen;
extern VScreenType backscreen;
extern VScreenType background;
extern VScreenType starbackground;
#endif


#define Truecolor 0
#define FastAccess 1
#define VScreenToBuffer(scr) (scr->line[0])
#define SetPalette(palette) set_palette (palette)
#define BSetPixel(bitmap,x,y,color) *(BitmapToBuffer(bitmap)+(x)+(y)*MAPWIDTH)=color
#define SMySetPixel(screen,x,y,color) *(VScreenToBuffer(screen)+(x)+((y)>>8)*MAPWIDTH)=color
#define SSetPixel(x,y,color) putpixel(CURSCR,x,y,color)
/*
#define BSetPixel(bitmap,x,y,color) putpixel(bitmap,x,y,color)
#define SMySetPixel(scr,x,y,color) putpixel((scr),(x),(y)>>8,(color))
*/
/*
#define BSetPixel(bitmap,x,y,color) _putpixel(CURSCR,x,y,color)
#define SMySetPixel(scr,x,y,color) _putpixel((scr),(x),(y),(color))
*/
#define SetScreen(scr) CURSCR=scr;

void DrawBlackMaskedText (int x, int y, char *text);
void DrawWhiteMaskedText (int x, int y, char *text);
void DrawText (int x, int y, char *text);

void DrawRectangle (int x1, int y1, int x2, int y2, int color);

BitmapType CompileBitmap (int x, int y, RawBitmapType bitmap);

#define FillRectangle(x,y,x1,y1,color) rectfill(CURSCR,(x),(y),(x1)+(x),(y1)+(y),(color))
#define Line(x1,y1,x2,y2,color) line(CURSCR,(x1),(y1),(x2),(y2),(color))
#define HLine(x1,y1,x2,color) hline(CURSCR,(x1),(y1),(x2),(color))
#define PutBitmap(x,y,xsize,ysize,bitmap) draw_rle_sprite(CURSCR,(bitmap),(x),(y))
#define WaitRetrace() vsync()
#define EnableClipping() 
#define DisableClipping() 
#define ClearScreen() clear (CURSCR)
extern void flippage(void);

void CopyVSToVS (VScreenType source, VScreenType destination);
void CopyToScreen (VScreenType source);

#define CharX 8
#define CharY 8
/* #define FAST_WIDELINE */

RawBitmapType CreateBitmap (int x, int y);

#define SGetPixel(x,y)          getpixel(CURSCR,(x),(y))
#define SPutPixel(x,y,c)        putpixel(CURSCR,(x),(y),(c))
