/*
 * sound.c - Platform Independant Sound Support - Apr. 1995
 *
 * Copyright 1994-1995 Sujal M. Patel (smpatel@wam.umd.edu)
 * Conditions in "copyright.h"
 *
 * Modified for koules and bugfixed by Jan Hubicka
 */
#ifdef SOUND

#include <stdio.h>
#ifdef __STDC__
#include <stdlib.h>
#endif

#include <allegro.h>
#include "koules.h"

#define playSounds 1

static char     sound_flags[20];        /* Sound Flag for sound 1-19 */

/* RAW sample parameters */
#define SAMPLESPERSEC 8000
#define BITSPERSAMPLE    8
#define CHANNELS         1

/* The samples to load */
char           *FILENAME[] =
{
 "start.wav",
 "end.wav",
 "colize.wav",
 "destroy1.wav",
 "destroy2.wav",
 "creator1.wav",
 "creator2.wav"
};


#define NUM_SOUNDS      (sizeof(FILENAME)/sizeof(char*))

SAMPLE* samples[NUM_SOUNDS];

void test_sound ()
{

}

void init_sound ()
{
 int z;
 install_sound(DIGI_AUTODETECT,MIDI_NONE,0);
 for (z=0;z<NUM_SOUNDS;z++)
 {
  char f[256];
  sprintf(f,"SOUNDS\\%s",FILENAME[z]);
  samples[z]=load_wav(f);
  if (!samples[z])
    {
      fprintf(stderr, "Failed to load sound file %s, sound disabled\n", f);
      snd = sndinit = 0; /* Not sure of the exact semantics here... */
      return;
    }
 }
}

int
play_sound (k)
     int             k;
{
  char            c;
  test_sound ();
  c = k;
  if (playSounds)
    play_sample(samples[k],255,128,1000,FALSE);
  return 0;
}



void
maybe_play_sound (k)
     int             k;
{
  char            c;

  if (sound_flags[k] & 1)
    return;

  sound_flags[k] |= 1;
  test_sound ();
  c = (unsigned char) (k);
  if (playSounds)
    play_sample(samples[k],255,128,1000,FALSE);
}



void
sound_completed (k)
     int             k;
{
  sound_flags[k] &= ~1;
}



void
kill_sound ()
{
}
#endif
